/*
 * Simple Demonstration for RatingRadioRenderer
 * by PhilFlash - http://philflash.inway.fr
 *
 */
 
import mx.controls.Button;

import mx.data.components.XMLConnector;
import mx.data.components.DataSet;
import mx.controls.DataGrid;
import mx.controls.gridclasses.DataGridColumn;

import mx.styles.CSSStyleDeclaration;
import mx.utils.Iterator;
import mx.data.to.ValueListIterator;

class form.InstructorForm extends mx.screens.Form {
 
	public var instructorDataGrid:DataGrid;
	public var instructorDataSet:DataSet;	
	private var instructorXMLConnector:XMLConnector;
	
	private var showButton:Button;
	
 	// Constructor
 	public function InstructorForm() {}

 	// -----   ----- 	
 	public function init():Void {
 		super.init();
 	}

 	// -----   ----- 	
 	public function onLoad():Void {
 	
		//setVisible(false);
		instructorXMLConnector.trigger();
		
		showButton.addEventListener("click", function(evt:Object) { evt.target._parent.showAction(evt); } );
		
		// Title 
		var titles = ["title"];
		var length = titles.length;
 		for (var i = 0; i < length; i++) {
 			var component = this[titles[i]];	
			component.editable = false;
			component.setStyle("styleName", "h1");
			component.setStyle("backgroundColor", 0xEBF0F9);
			// haut
			component.setStyle("buttonColor", 0xEBF0F9);
			component.setStyle("highlightColor", 0xEBF0F9);
			// cote
			component.setStyle("shadowCapColor", 0xEBF0F9);
			component.setStyle("borderCapColor", 0xEBF0F9);
			// bas
			component.setStyle("shadowColor", 0xE8F0F1);
			component.setStyle("borderColor", 0x517DBF);
		}
		
		initGrid();
		
 		var label = this["label_rating"];
		label.setStyle("styleName", "labelTitre");

	}
	// -----   -----	
 	private function initGrid():Void {
		var datagrid:DataGrid = instructorDataGrid;
		var col:mx.controls.gridclasses.DataGridColumn;
		
		datagrid.removeAllColumns();
		
		col = new mx.controls.gridclasses.DataGridColumn("label");
		col.headerText = "aa";
		col.editable = false;
		col.resizable = true;
		col.sortable = false;
		col.sortOnHeaderRelease = false;
		col.width = datagrid.width-120-18;
		datagrid.addColumn(col);

		col = new mx.controls.gridclasses.DataGridColumn("value");
		col.headerText = "bb";
		col.editable = false;
		col.resizable = true;
		col.sortable = false;
		col.sortOnHeaderRelease = false;
		col.cellRenderer = "RatingRadioRenderer";		
		col.width = 120;
		datagrid.addColumn(col);
		
		initGridStyle();
		
	 }
	// -----   -----
	private function initGridStyle():Void {
		var datagrid:DataGrid = instructorDataGrid;
		
		datagrid.setStyle("styleName", "labelTableau");
		datagrid.setStyle("alternatingRowColors", Array(0xFFFFFF, 0xF8FAFB));
		datagrid.setRowHeight(24);

		datagrid.setStyle("hGridLines", true);
		datagrid.setStyle("hGridLineColor", 0xC1D1E0);
		datagrid.setStyle("vGridLines", true);
		datagrid.setStyle("vGridLineColor", 0xC1D1E0);

		datagrid.setStyle("borderStyle", "inset");
		// haut
		datagrid.setStyle("buttonColor", 0xFFFFFF);
		datagrid.setStyle("highlightColor", 0xFFFFFF);
		// cote
		datagrid.setStyle("borderCapColor", 0xFFFFFF);
		datagrid.setStyle("shadowCapColor", 0xFFFFFF);
		// bas
		datagrid.setStyle("shadowColor", 0x336699);
		datagrid.setStyle("borderColor", 0xFFFFFF);

		//datagrid.resizableColumns = false;
		//datagrid.setVScrollPolicy("off");

		// themeColor
		datagrid.setStyle("themeColor", 0xADC1D6); 
		datagrid.setStyle("useRollOver", false);
		datagrid.setStyle("textSelectedColor", 0x333333);

		// useRollOver -> pour Header quand on click
		datagrid.setStyle("rollOverColor", 0xFFFFFF);

		// Header
		// No header in this example
		datagrid.setShowHeaders(false);
	}

 	// -----   -----
	public function showAction(evt:Object):Void {
		setVisible(false);
		(rootForm).formXML.setVisible(true);
	}
 	// -----  -----
 	// Generate XML
	public function toXML(document:XML):Void {
		var rootNode = document.firstChild;  
		
		var dpCursor:ValueListIterator = instructorDataSet.getIterator();
		while (dpCursor.hasNext()) {
			dpCursor.next();
			var currentItem = dpCursor.getCurrentItem();

			var node = document.createElement("rating");
			// Ordre inverse pour avoir bon ordre dans attributs
			node.attributes.value = currentItem.value;
			node.attributes.label = currentItem.label;
			node.attributes.id = currentItem.id;
			
			rootNode.appendChild(node);
		}
	}
}
